<template>
    <div class="container ">
      <div class="row ">
        <div class="col-12 ">
        <h2 class="m-2 row">
            <span class="col-md-10 text-truncate">{{book.title}} valorations</span>
            <span class="col-md-2"><button @click="$modal.show('modalPost')" class="btn btn-info btn">Post </button></span>
        </h2>
        </div>
      </div>
        <transition-group name="new-transition">
        <div class="card card-inner new-transition-item" v-for="(comment, key ) in sortedcomments" :key="key+'comment'">
            <div class="card-body p-2">
                <div class="row">
                    <div class="col-md-2 p-0 pl-2 d-flex flex-column justify-content-center  align-items-center" >
                         <userImage :user="comment.user" size="lg"></userImage>
                        <div class="text-center">
                            <p class="h6">{{comment.user.name}}</p>
                            <p class="text-secondary ">{{since(comment.createdAt)}}</p>
                        </div>
                    </div>
                    <div class="col-md-10 ">
                    <div class="row d-flex flex-row align-items-center justify-content-between">
                        <div class="col-sm-5 col-12 author text-center text-sm-left" ><strong class="text-secondary">{{comment.user.name}}</strong></div>
                        <div class="col-sm-6 col-12 d-flex flex-row align-items-center justify-content-center p-0 ">
                            <span  class="col-1 p-0 m-0 ml-1 mr-1" v-for="(key) in comment.comment_valoration" :key="key">
                              <font-awesome-icon color="goldenrod" class="likes p-1" icon="star"/>
                            </span>
                        </div>
                        <div class="col-1 mt-0 p-0">
                          <span class="btn m-t0" title="Remove valoration" v-if="user.id==comment.user.id" @click="deleteComment(comment)">
                            <font-awesome-icon color="firebrick" icon="times" size="lg"/>
                          </span>
                        </div>
                    </div>
                    <div class="clearfix ml-4 mt-2" ></div>
                        <p class="ml-sm-5">{{comment.comment}}</p>
                    </div>
                </div>
            </div>
        </div>
        </transition-group>
        <modalPost  @post="post=>sendPost(post)"></modalPost>
    </div>
</template>
<script>
import EventBus from '../../main';
const $ = require("jquery");
import userImage from '../userImage'
import moment from 'moment';
import modalPost from '../modals/ModalPost'
moment.locale('en');
moment().utcOffset()
export default {
  beforeDestroy(){
    this.$socket.off('resBookComment');
  },
  created:function(){
  this.$socket.on('resDeleteValoration',data=>{
    if(this.book._id==data.bookId){
      this.comments=[]
      this.getComments();
    }
  })
    this.$socket.on('resBookComment',data=>{
      if(this.book._id==data.bookId){
        if(data.newValoration){
          this.comments.push(data.post)
        }else {
          this.$toastr.error(
            this.book.title + " has already been valued by you",
            "Posting, error",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: 'toast-bottom-right',
          })
        }
      }
    })
    this.$socket.on('resComments',comments=>{
      this.comments=comments
    })
    this.getComments();
  } ,
  name : 'post',
  props : [
      'book',
      'serverId'
  ],
  components :{
      userImage,
      moment,
      modalPost,
  },
  data(){
      return {
        comments:[],
        textcomment:null,
        newComment:false,
        token: localStorage.getItem("jwt"),
        user:JSON.parse(localStorage.getItem("user")),
      }
  },
  computed: {
    sortedcomments:function(){
      return this.comments.sort(
        function(a,b){
          if(a.createdAt>b.createdAt) return 1
           else return -1
        }
      )
    }
  },
  methods : {
     like(val){
         if((val < 0 && this.likes-1>=0) || (val>0 && this.likes+1<=5) )  this.likes=this.likes+val;
     },
    since: function(d){
        return moment(d).fromNow();
    },
       sendPost(post){
        this.$socket.emit('reqBookComment',{
          bookId:this.book._id,
          post:post,
          token:this.token,
          user:this.user,
          serverId:this.serverId
        })
      },
    getComments: function(){
      this.$socket.emit('reqComments',{
        bookId:this.book._id,
        token:this.token,
        userId:this.user.id,
        serverId:this.serverId
      })
    },

    deleteComment: function(comment){
      this.$socket.emit("reqDeleteValoration",{
        bookId:this.book._id,
        token:this.token,
        user:this.user,
        serverId:this.serverId,
        commentId:comment._id,
      })
    }
  }
}
</script>
<style>
    .photoFrame{
        border-radius:50%;
        background-color: lightgray;
        width: 80%;
        padding: 10px;
        z-index: 100;
    }
    .author{
        font-size :2em;
        color: darkblue;
    }
    .form-rounded{
        border-radius: 1rem;
    }
    .new-transition-enter-active {
    transition: all 0.8s;
}
.new-transition-enter{
  opacity: 0;
  transform: translateY(30px);
}
.new-transition-leave-to{
  opacity: 0;
  transform: translateY(30px);
}
.img-fluid-margin{
    border-radius: 50%;
    z-index: 1000
}
</style>

